#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf mdadm-2.6.9.tar.bz2
    cd mdadm-2.6.9
    sed -i -e 's/\<-Werror\>//' Makefile
    make CXFLAGS="$CFLAGS"
    strip -R .note -R .comment mdadm
    mkdir -p ../mdadm/sbin
    cp mdadm ../mdadm/sbin/
    cd ..
    rm -rf mdadm-2.6.9
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
